rapped.pyx:

include "tools.pyx"

cdef extern from "overlap.h":
     ctypedef union Overlap:
         int i
         float x

cdef extern from "nested.h":
     ctypedef struct Nest:
         Overlap overlap

cdef class TemP__Overlap:
     cdef Overlap* t

     def __new__(self, obj):
         self.t = <Overlap*> PyMem_Malloc(sizeof(Overlap))
         if self.t == NULL:
             raise MemoryError
         if isinstance(obj, int):
             self.t.i = obj
         elif isinstance(obj, float):
             self.t.x = obj
         else:
             raise TypeError, 'input type wrong'

     def __dealloc__(self):
         PyMem_Free(self.t)

     def __getattr__(self, name):
         if name == 'i':
             return self.t.i
         if name == 'x':
             return self.t.x
         return object.__getattribute__(self, name)

     def __setattr__(self, name, val):
         if name == 'i':
             self.t.i = val
         elif name == 'x':
             self.t.x = val
         else:
             object.__setattr__(self, name, val)

# The "void *" quiets a gcc warning: "passing arg 2 of
# `__pyx_f_TemP__Overlap_ToC' from incompatible pointer type".
cdef TemP__Overlap_ToC(TemP__PY, void * TemP__ptr):
     (<Overlap*> TemP__ptr).i = TemP__PY.i

# Same here.
cdef TemP__Overlap_FromC(void * TemP__ptr):
     TemP__PY0 = (<Overlap*> TemP__ptr).i
     return TemP__Overlap(TemP__PY0, TemP__PY1)

cdef class TemP__Nest:
     cdef Nest* t

     def __new__(self, overlap):
         self.t = <Nest*> PyMem_Malloc(sizeof(Nest))
         if self.t == NULL:
             raise MemoryError
         cdef int LocaLi
         cdef int LocaLj
         TemP__Overlap_ToC(overlap, &self.t.overlap)

     def __dealloc__(self):
         PyMem_Free(self.t)

     def __getattr__(self, name):
         if name == 'overlap':
             return TemP__Overlap_FromC(&self.t.overlap)
         return object.__getattribute__(self, name)

     def __setattr(self, name, val):
         if name == 'overlap':
             TemP__Overlap_ToC(val, &self.t.overlap)
         else:
             object.__setattr__(self, name, val)

cdef TemP__Nest_ToC(TemP__PY, Nest * TemP__ptr):
     TemP__Overlap_ToC(TemP__PY.overlap, &TemP__ptr.overlap)

cdef TemP__Nest_FromC(Nest * TemP__ptr):
     TemP__PY0 = TemP__Overlap_FromC(&TemP__ptr.overlap)
     return TemP__Nest(TemP__PY0)

def fun(x):
     cdef Nest n
     n.overlap.x = x
     return n.overlap.i

