
import os,sys
from distutils.core import setup, Extension
from distutils.sysconfig import get_python_inc
import numpy

numdir = os.path.dirname(numpy.__file__)+"/core/include/numpy"

pgalib = "pgapack/lib/"+os.listdir("pgapack/lib")[0]

setup(name="pgapack",version="1.0",
     description="Python Interface to pgapack",
     author="Daniel D. Kelson",
     author_email="kelson@ociw.edu",
     url="http://www.ociw.edu/~kelson",
     extra_path="pgapack",
     ext_modules=[Extension("pgapack",
             ["pgapack.c"],
             define_macros=[("WL","32")],
             include_dirs=["pgapack/include",numdir],
             library_dirs=["./","/usr/lib",os.environ["PYTHONBASE"]+"/lib",pgalib],
             libraries=["pgaO","gcc","m","c"],
                     )])

