#!/usr/bin/env python

from Numeric import *
from pgapack import *
from sys import argv

#print dir()

def griewank(x):
    tot = sum(power(x,2)/4000.0)
    prod = multiply.reduce(cos(x/sqrt(arange(len(x))+1)))
    f = 1+tot-prod
    return f

it = int(argv[1])
N = 10
b = Context(PGA_DATATYPE_REAL, N, PGA_MINIMIZE,["--pgahelp"])
l = -512.0*ones((N,),Float64)
u = 511.0*ones((N,),Float64)
b.Set("RandomSeed",1)
b.Set("RealInitRange",l,u)
b.Set("MaxGAIterValue",it)
b.SetUp()
b.Run(griewank)


